Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.Designer.cs	(revision 12124)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.Designer.cs	(revision 12125)
@@ -154,5 +154,4 @@
       this.itemsListView.DoubleClick += new System.EventHandler(this.itemsListView_DoubleClick);
       this.itemsListView.KeyDown += new System.Windows.Forms.KeyEventHandler(this.itemsListView_KeyDown);
-      this.itemsListView.KeyUp += new System.Windows.Forms.KeyEventHandler(this.itemsListView_KeyUp);
       // 
       // imageList
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs	(revision 12124)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs	(revision 12125)
@@ -257,9 +257,5 @@
             Content[item.Index] = null;
         }
-      }
-    }
-
-    protected virtual void itemsListView_KeyUp(object sender, KeyEventArgs e) {
-      if (e.KeyData == (Keys.Control | Keys.C)) {
+      } else if (e.KeyData == (Keys.Control | Keys.C)) {
         if (itemsListView.SelectedItems.Count > 0) {
           var builder = new StringBuilder();
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.Designer.cs	(revision 12124)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.Designer.cs	(revision 12125)
@@ -107,5 +107,4 @@
       this.itemsListView.DoubleClick += new System.EventHandler(this.itemsListView_DoubleClick);
       this.itemsListView.KeyDown += new System.Windows.Forms.KeyEventHandler(this.itemsListView_KeyDown);
-      this.itemsListView.KeyUp += new System.Windows.Forms.KeyEventHandler(this.itemsListView_KeyUp);
       // 
       // imageList
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 12124)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 12125)
@@ -242,8 +242,5 @@
           }
         }
-      }
-    }
-    protected virtual void itemsListView_KeyUp(object sender, KeyEventArgs e) {
-      if (e.KeyData == (Keys.Control | Keys.C)) {
+      } else if (e.KeyData == (Keys.Control | Keys.C)) {
         if (itemsListView.SelectedItems.Count > 0) {
           var builder = new StringBuilder();
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.Designer.cs	(revision 12124)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.Designer.cs	(revision 12125)
@@ -155,5 +155,4 @@
       this.itemsListView.DoubleClick += new System.EventHandler(this.itemsListView_DoubleClick);
       this.itemsListView.KeyDown += new System.Windows.Forms.KeyEventHandler(this.itemsListView_KeyDown);
-      this.itemsListView.KeyUp += new System.Windows.Forms.KeyEventHandler(this.itemsListView_KeyUp);
       // 
       // imageList
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs	(revision 12124)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs	(revision 12125)
@@ -262,9 +262,5 @@
             Content.RemoveAt(item.Index);
         }
-      }
-    }
-
-    protected virtual void itemsListView_KeyUp(object sender, KeyEventArgs e) {
-      if (e.KeyData == (Keys.Control | Keys.C)) {
+      } else if (e.KeyData == (Keys.Control | Keys.C)) {
         if (itemsListView.SelectedItems.Count > 0) {
           var builder = new StringBuilder();