Index: branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj
===================================================================
--- branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj	(revision 12109)
+++ branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj	(revision 12141)
@@ -177,4 +177,10 @@
     <Compile Include="Interfaces\IDataPreprocessorStarter.cs" />
     <Compile Include="MenuItems\ShrinkDataAnalysisRunsMenuItem.cs" />
+    <Compile Include="ModifiableDatasetView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="ModifiableDatasetView.Designer.cs">
+      <DependentUpon>ModifiableDatasetView.cs</DependentUpon>
+    </Compile>
     <Compile Include="Plugin.cs" />
     <Compile Include="ProblemDataView.cs">
Index: branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/ModifiableDatasetView.Designer.cs
===================================================================
--- branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/ModifiableDatasetView.Designer.cs	(revision 12141)
+++ branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/ModifiableDatasetView.Designer.cs	(revision 12141)
@@ -0,0 +1,32 @@
+﻿namespace HeuristicLab.Problems.DataAnalysis.Views {
+  partial class ModifiableDatasetView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      components = new System.ComponentModel.Container();
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+    }
+
+    #endregion
+  }
+}
Index: branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/ModifiableDatasetView.cs
===================================================================
--- branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/ModifiableDatasetView.cs	(revision 12141)
+++ branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/ModifiableDatasetView.cs	(revision 12141)
@@ -0,0 +1,75 @@
+﻿#region License Information
+
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#endregion
+
+using System.Windows.Forms;
+using HeuristicLab.Data.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Problems.DataAnalysis.Views {
+  [View("ModifiableDataset View")]
+  [Content(typeof(ModifiableDataset), true)]
+  public partial class ModifiableDatasetView : StringConvertibleMatrixView {
+    public new ModifiableDataset Content {
+      get { return (ModifiableDataset)base.Content; }
+      set {
+        if (base.Content != value)
+          base.Content = value;
+      }
+    }
+
+    public ModifiableDatasetView() {
+      InitializeComponent();
+    }
+
+    #region register/deregister content events
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      dataGridView.CellContentDoubleClick += dataGridView_cellContentDoubleClicked;
+      dataGridView.CellLeave += dataGridView_cellLeave;
+    }
+
+    protected override void DeregisterContentEvents() {
+      dataGridView.CellContentDoubleClick -= dataGridView_cellContentDoubleClicked;
+      dataGridView.CellLeave -= dataGridView_cellLeave;
+      base.DeregisterContentEvents();
+    }
+    #endregion
+
+    #region event handlers
+    private void dataGridView_cellContentDoubleClicked(object sender, DataGridViewCellEventArgs args) {
+      var currentCell = dataGridView[args.ColumnIndex, args.RowIndex];
+      dataGridView.ReadOnly = false;
+      currentCell.ReadOnly = false;
+      dataGridView.CurrentCell = currentCell;
+      dataGridView.BeginEdit(true);
+    }
+
+    private void dataGridView_cellLeave(object sender, DataGridViewCellEventArgs args) {
+      var currentCell = dataGridView[args.ColumnIndex, args.RowIndex];
+      dataGridView.ReadOnly = true;
+      currentCell.ReadOnly = true;
+      dataGridView.EndEdit();
+    }
+    #endregion
+  }
+}
Index: branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Problems.DataAnalysis/3.4/Dataset.cs
===================================================================
--- branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Problems.DataAnalysis/3.4/Dataset.cs	(revision 12109)
+++ branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Problems.DataAnalysis/3.4/Dataset.cs	(revision 12141)
@@ -222,8 +222,8 @@
       return variableValues[variableNames[columnIndex]][rowIndex].ToString();
     }
-    public bool SetValue(string value, int rowIndex, int columnIndex) {
+    bool IStringConvertibleMatrix.SetValue(string value, int rowIndex, int columnIndex) {
       throw new NotSupportedException();
     }
-    public bool Validate(string value, out string errorMessage) {
+    bool IStringConvertibleMatrix.Validate(string value, out string errorMessage) {
       throw new NotSupportedException();
     }
Index: branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Problems.DataAnalysis/3.4/ModifiableDataset.cs
===================================================================
--- branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Problems.DataAnalysis/3.4/ModifiableDataset.cs	(revision 12109)
+++ branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Problems.DataAnalysis/3.4/ModifiableDataset.cs	(revision 12141)
@@ -28,4 +28,5 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Data;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -33,5 +34,5 @@
   [Item("ModifiableDataset", "Represents a dataset containing data that should be analyzed, which can be modified by adding or replacing variables and values.")]
   [StorableClass]
-  public class ModifiableDataset : Dataset {
+  public class ModifiableDataset : Dataset, IStringConvertibleMatrix {
     [StorableConstructor]
     private ModifiableDataset(bool deserializing) : base(deserializing) { }
@@ -99,5 +100,5 @@
     }
 
-    public void ChangeVariableValue(object value, string variableName, int row) {
+    public void SetVariableValue(object value, string variableName, int row) {
       IList list;
       variableValues.TryGetValue(variableName, out list);
@@ -106,4 +107,7 @@
       if (row < 0 || list.Count < row)
         throw new ArgumentOutOfRangeException("Invalid row value");
+      if (GetVariableType(variableName) != value.GetType())
+        throw new ArgumentException("The type of the provided value does not match the variable type.");
+
       list[row] = value;
     }
@@ -116,4 +120,42 @@
       return list[0].GetType();
     }
+
+    bool IStringConvertibleMatrix.SetValue(string value, int rowIndex, int columnIndex) {
+      var variableName = variableNames[columnIndex];
+      // if value represents a double
+      double dv;
+      if (double.TryParse(value, out dv)) {
+        SetVariableValue(dv, variableName, rowIndex);
+        return true;
+      }
+      // if value represents a DateTime object
+      DateTime dt;
+      if (DateTime.TryParse(value, out dt)) {
+        SetVariableValue(dt, variableName, rowIndex);
+        return true;
+      }
+      // if value is simply a string
+      SetVariableValue(value, variableName, rowIndex);
+      return true;
+    }
+
+    bool IStringConvertibleMatrix.Validate(string value, out string errorMessage) {
+      return ValidateValue(value, out errorMessage);
+    }
+
+    private static bool ValidateValue(string value, out string errorMessage) {
+      double dv;
+      if (double.TryParse(value, out dv)) {
+        errorMessage = string.Empty;
+        return true;
+      }
+      DateTime dt;
+      if (DateTime.TryParse(value, out dt)) {
+        errorMessage = string.Empty;
+        return true;
+      }
+      errorMessage = "Value could not be validated. Please ensure that the value is either a string, a double, or a DateTime value.";
+      return false;
+    }
   }
 }